%global srcname execnet

Summary:       Distributed Python deployment and communication
Name:          python-%{srcname}
Version:       2.0.2
Release:       3%{?dist}
License:       MIT
URL:           https://github.com/pytest-dev/execnet
Source0:       %pypi_source

BuildRequires: make %{_bindir}/ps
BuildArch:     noarch

%description
execnet provides a share-nothing model with channel-send/receive communication for distributing
execution across many Python interpreters across version, platform and network barriers. It has a
minimal and fast API targetting the following uses:

 * distribute tasks to (many) local or remote CPUs
 * write and deploy hybrid multi-process applications
 * write scripts to administer multiple environments

%package -n python3-%{srcname}
Summary:       Elastic Python Deployment
BuildRequires: python3-devel python3-setuptools python3-setuptools_scm python3-pytest
BuildRequires: python3-pytest-timeout %{_bindir}/sphinx-build-3

%description -n python3-%{srcname}
execnet provides a share-nothing model with channel-send/receive communication for distributing
execution across many Python interpreters across version, platform and network barriers. It has a
minimal and fast API targetting the following uses:

 * distribute tasks to (many) local or remote CPUs
 * write and deploy hybrid multi-process applications
 * write scripts to administer multiple environments

%prep
%autosetup -p1 -n %{srcname}-%{version}
find . -type f -a \( -name '*.py' -o -name 'py.*' \) \
   -exec sed -i '1{/^#!/d}' {} \; \
   -exec chmod u=rw,go=r {} \;

%generate_buildrequires
%pyproject_buildrequires

%build
%pyproject_wheel

%install
%pyproject_install

%check
PYTEST_SELECT='not test_popen_io[gevent-sys.executable]'
PYTEST_SELECT+=' and not [gevent-socket]'
PYTEST_SELECT+=' and not [eventlet-socket]'
PYTEST_SELECT+=' and not [python2.7]'
PYTHONPATH=$(pwd)/src \
py.test-%{python3_version} -r s \
  -k "$PYTEST_SELECT" \
  testing \
  --timeout=30

%files -n python3-%{srcname}
%license LICENSE
%doc README.rst
%{python3_sitelib}/%{srcname}*/

%changelog
* Mon Sep 2 2024 Shuo Wang <abushwang@tencent.com> - 2.0.2-3
- remove unused BuildRequires

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.0.2-2
- Rebuilt for loongarch release

* Mon Sep 25 2023 Shuo Wang <abushwang@tencent.com> - 2.0.2-1
- update to 2.0.2

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.9.0-5
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.9.0-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.9.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.9.0-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Feb 9 2023 Shuo Wang <abushwang@tencent.com> - 1.9.0-1
- initial build
